module A_Button(  --This is the Attributed button module.
  A_Button, 
  a_button, 
  set, 
  title, 
  onPress, 
  position, 
  size, 
  (=:),
) where

import Button
import Attributes

data A_Button = New_A_Button ButtonPtr

--Converts the A_Button to a button pointer (simply for convinience)
b2A (New_A_Button a) = a

-- The A_Button constructor
a_button :: [Prop A_Button] -> IO A_Button
a_button props = do
  a <- newButton 0 0 300 50 "Button"
  let w = New_A_Button a
  set w props
  return w

title = newAttr (\w   -> button_memfun_getLabel (b2A w) )
                (\w x -> button_memfun_setLabel (b2A w) x)

onPress = newAttr (\w  -> return (button_memfun_do_callback (b2A w)) )
                  (\w x-> (button_memfun_callback (b2A w) x) )

position = newAttr 
  (\w  -> 
    do
      a <- button_memfun_x (b2A w)
      b <- button_memfun_y (b2A w)
      return (a,b) )
  (\w (a,b) -> button_memfun_position (b2A w) a b )

size = newAttr 
  (\w  -> 
    do
      a <- button_memfun_w (b2A w)
      b <- button_memfun_h (b2A w)
      return (a,b) )
  (\w (a,b) -> button_memfun_size (b2A w) a b )
