module Window (
  WindowPtr,
  newWindow,
  window_memfun_end,
  window_memfun_show
) where

import Foreign
import Foreign.C

data Window = Window ()

data WindowPtr = WindowPtr (ForeignPtr Window)

foreign import ccall f_newWindow :: Int -> Int -> IO (Ptr Window)
foreign import ccall f_deleteWindow :: (Ptr Window) -> IO ()
foreign import ccall f_Window_memfn_end :: (Ptr Window) -> IO ()
foreign import ccall f_Window_memfn_show :: (Ptr Window) -> IO ()

newWindow :: Int -> Int -> IO WindowPtr
newWindow a b = do
  it <- f_newWindow a b
  fptr <- newForeignPtr it (f_deleteWindow it)
  return (WindowPtr fptr)

window_memfun_end a = do
  let WindowPtr  b = a
  f_Window_memfn_end $ foreignPtrToPtr b
  touchForeignPtr b
  return ()

window_memfun_show a = do
  let WindowPtr  b = a
  f_Window_memfn_show $ foreignPtrToPtr b
  touchForeignPtr b
  return ()
